'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = normalizrMiddleware;

var _normalizr = require('normalizr');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function normalizrMiddleware() {
  return function (store) {
    return function (next) {
      return function (action) {
        var schema = action.meta && action.meta.schema;

        if (schema) {
          var normalized = (0, _normalizr.normalize)(action.payload, schema);
          action = (0, _objectAssign2.default)({}, action, { payload: normalized });
        }

        return next(action);
      };
    };
  };
}
